<template>
  <div>
    <div
      id="modal_producto_mostrar"
      class="modal fade"
      tabindex="-1"
      aria-hidden="true"
      data-bs-backdrop="static"
      data-bs-keyboard="false"
    >
      <div class="modal-dialog mw-750px">
        <div
          id="modal_producto_mostrar_formulario"
          class="modal-content rounded"
        >
          <div class="modal-header d-flex justify-content-end">
            <div
              id="modal_producto_mostrar_btn_cerrar"
              class="btn btn-icon btn-sm btn-active-light-primary ms-2"
              data-bs-dismiss="modal"
              aria-label="Close"
              @click="onCerrarModal()"
            >
              <i class="bi bi-x-lg" />
            </div>
          </div>

          <div class="modal-body scroll-y px-10 px-lg-15 pt-0 pb-0">
            <div
              v-if="response.mostrar === 'LOADING'"
              class="d-flex justify-content-center py-20"
            >
              <div
                class="spinner-border text-primary"
                style="width: 4rem; height: 4rem; border-width: 0.35rem"
                role="status"
              >
                <span class="visually-hidden">Cargando...</span>
              </div>
            </div>

            <div
              v-else
              class="d-flex flex-column flex-wrap flex-sm-nowrap mb-3 mt-3"
            >
              <div class="d-flex flex-wrap mb-5">
                <div class="me-7 mb-4">
                  <div class="symbol symbol-100px symbol-lg-150px symbol-fixed position-relative">
                    <img
                      :src="mProducto.urlFoto"
                      alt="Imagen del producto"
                    >
                  </div>
                </div>
                <div class="flex-grow-1">
                  <div class="d-flex justify-content-between align-items-start flex-wrap">
                    <div class="d-flex flex-column">
                      <div class="d-flex">
                        <label class="text-gray-900 fs-3 fw-bolder">{{ mProducto.nombre }}</label>
                      </div>
                      <div class="d-flex fw-bold fs-5">
                        <label class="d-flex align-items-center text-gray-600 me-5 mb-2">
                          {{ mProducto.tipoUnidad }}
                        </label>
                      </div>
                      <div class="d-flex">
                        <div class="fw-bolder fs-5">
                          Precio:
                        </div>
                        <div class="fw-bold fs-5 ms-3">
                          {{ mProducto.precio + ' ' + mProducto.tipoMoneda }}
                        </div>
                      </div>
                      <div class="d-flex">
                        <div class="fw-bolder fs-5">
                          Descuento gratuito:
                        </div>
                        <div class="fw-bold fs-5 ms-3">
                          {{ mProducto.descuentoGratuito + '%' }}
                        </div>
                      </div>
                      <div class="d-flex">
                        <div class="fw-bolder fs-5">
                          Descuento premium:
                        </div>
                        <div class="fw-bold fs-5 ms-3">
                          {{ mProducto.descuentoPremium + '%' }}
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>

              <div class="d-flex flex-wrap">
                <div v-html="mProducto.descripcion" />
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import Servicio from "@/core/servicio/Servicio";
import Ruta from "@/core/servicio/Ruta";
import Toast from "@/core/util/Toast";

export default {
  name: 'ProductoMostrar',
  components: {
  },
  props: {
    producto: { type: Object, required: true, default() {
        return {
          id: {type: Number, required: true}
        }
      }
    }
  },
  data() {
    return {
      mProducto: {},
      response: {
        mostrar: 'LOADING',
      }
    }
  },

  watch: {
    producto: function() {
      this.onProductoMostrar();
    }
  },

  methods: {
    onProductoMostrar() {
      this.response.mostrar = 'LOADING';
      Servicio.get(Ruta.rutaPanelProductoMostrar(this.$route.params.id, this.producto.id)).then( (data) => {
        this.mProducto = data.data;
        this.response.mostrar = data.estado;
      }).catch( (error) => {
        this.response.mostrar = 'ERROR';
        Toast.mostrarError(error);
      });
    },

    onCerrarModal() {
      this.mProducto = {urlFoto: '', nombre: '', tipoUnidad: ''};
    },
  },
}

</script>